@echo off
setlocal

set EXAMPLE=%1
set MODE=%2

set EXAMPLES_DIR=%~dp0\..

if "%EXAMPLE%"=="" (
   echo You must supply the name of an example to build.
   goto exit
)

if "%INCLUDE%"=="" (
   echo This command must be executed from a Visual Studio command prompt.
)
  
rem remove any double quotes in the environment variable

for /f "tokens=* delims=" %%J in (%COHERENCE_CPP_HOME%) do ( set NEW_COHERENCE_CPP_HOME=%%J)
rem if there were no double quotes, the new environment variable will not be set
if "%NEW_COHERENCE_CPP_HOME%"=="" (
    set NEW_COHERENCE_CPP_HOME=%COHERENCE_CPP_HOME%
   )

if "%NEW_COHERENCE_CPP_HOME%"=="" (
  echo COHERENCE_CPP_HOME is not set!
  echo set COHERENCE_CPP_HOME to a Coherence C++ installation.
  goto exit
)

set MODEL_OUT_DIR=%EXAMPLES_DIR%\model\out\

call %EXAMPLES_DIR%\bin\build_model.cmd %MODE%

SET EXAMPLES_OUT_DIR=%EXAMPLES_DIR%\%EXAMPLE%\out

if exist %MODEL_OUT_DIR% (
   rd /s /q %EXAMPLES_OUT_DIR%
   mkdir %EXAMPLES_OUT_DIR%
) else (
   mkdir %EXAMPLES_OUT_DIR%
)

cd %EXAMPLES_OUT_DIR%
 
set OPT=/D "WIN32" /D "_CRT_SECURE_NO_WARNINGS" /D "_CONSOLE" /D "_UNICODE" /D "UNICODE" /FD /EHsc /c 
set LOPT=/NOLOGO /SUBSYSTEM:CONSOLE /INCREMENTAL:NO
set INC=/I "%EXAMPLES_DIR%\model" /I "%NEW_COHERENCE_CPP_HOME%\include"
set SRC=%EXAMPLES_DIR%\%EXAMPLE%\*.cpp
set OUT=%EXAMPLES_OUT_DIR%\%EXAMPLE%.exe
set LIBPATH="%NEW_COHERENCE_CPP_HOME%\lib";%MODEL_OUT_DIR%\;%LIBPATH% 

set LIBS=kernel32.lib "%NEW_COHERENCE_CPP_HOME%\lib\coherence.lib" %MODEL_OUT_DIR%\model.lib

if "%MODE%"=="debug" (
    set OPT=%OPT% /Zi /MDd
  ) else (
    set OPT=%OPT% /O2 /MD
  )

if "%EXAMPLE%"=="console" (
    echo The console is an embedded application; no compilation is necessary.
  ) else (
    echo building %OUT% ...
    cl %OPT% %INC% %SRC%
    link %LOPT% %LIBS% *.obj /OUT:%OUT%
    mt -manifest %OUT%.manifest -outputresource:%OUT%;1

    rem del *.obj
  )

echo To run this example execute 'bin\run %EXAMPLE%'

:exit
