@echo off
setlocal

set EXAMPLES_DIR=%~dp0\..

set MODE=%1

if "%INCLUDE%"=="" (
    echo This command must be executed from a Visual Studio command prompt.
    goto exit
  )
  
rem remove any double quotes in the environment variable

for /f "tokens=* delims=" %%J in (%COHERENCE_CPP_HOME%) do ( set NEW_COHERENCE_CPP_HOME=%%J)
rem if there were no double quotes, the new environment variable will not be set
if "%NEW_COHERENCE_CPP_HOME%"=="" (
    set NEW_COHERENCE_CPP_HOME=%COHERENCE_CPP_HOME%
   )

if "%NEW_COHERENCE_CPP_HOME%"=="" (
   echo COHERENCE_CPP_HOME is not set!
   echo set COHERENCE_CPP_HOME to a Coherence C++ installation.
   goto exit
)

set MODEL_OUT_DIR=%EXAMPLES_DIR%\model\out\
set OPT=/FD /EHsc  /W3 /nologo /c /Zi /TP /DWIN32 /DMODEL_EXPORTS /D_USRDLL /D_WINDOWS /D_CRT_SECURE_NO_WARNINGS  /D "_WINDLL" /D "_MBCS"
set LOPT=/DLL /MANIFEST /SUBSYSTEM:WINDOWS /OPT:REF /OPT:ICF /IMPLIB:"%MODEL_OUT_DIR%\model.lib"
set INC=/I"%NEW_COHERENCE_CPP_HOME%/include"  /I.
set SRC=%EXAMPLES_DIR%\model\*.cpp
set OUT=%MODEL_OUT_DIR%\model.dll
set LIBPATH="%NEW_COHERENCE_CPP_HOME%\lib";%LIBPATH%

if exist %MODEL_OUT_DIR% (
   rd /s /q %MODEL_OUT_DIR%
   mkdir %MODEL_OUT_DIR%
) else (
   mkdir %MODEL_OUT_DIR%
)

cd %MODEL_OUT_DIR%
 
set LIBS=kernel32.lib "%NEW_COHERENCE_CPP_HOME%\lib\coherence.lib"
 
if "%MODE%"=="debug" (
    set OPT=%OPT% /MTd
  ) else (
    set OPT=%OPT% /O2 /MT
  )

 echo building %MODEL_OUT_DIR% ...
 cl %OPT% %INC% %SRC%
 link %LOPT% %LIBS% *.obj /OUT:%OUT%
 mt -manifest %OUT%.manifest -outputresource:%OUT%;1

 del *.obj
 del %MODEL_OUT_DIR%\*.obj

:exit
