@echo off
setlocal

set EXAMPLE=%1

set EXAMPLES_DIR=%~dp0\..

if "%EXAMPLE%"=="" (
   echo You must supply the name of an example to run.
   goto exit
   )
   
rem remove any double quotes in the environment variable

for /f "tokens=* delims=" %%J in (%COHERENCE_CPP_HOME%) do ( set NEW_COHERENCE_CPP_HOME=%%J)
rem if there were no double quotes, the new environment variable will not be set
if "%NEW_COHERENCE_CPP_HOME%"=="" (
    set NEW_COHERENCE_CPP_HOME=%COHERENCE_CPP_HOME%
   )

if "%NEW_COHERENCE_CPP_HOME%"=="" (
  echo COHERENCE_CPP_HOME is not set!
  echo set COHERENCE_CPP_HOME to a Coherence C++ installation.
  goto exit
)

set MODEL_OUT_DIR=%EXAMPLES_DIR%\model\out\

set EXEC=%EXAMPLE%\out\%EXAMPLE%
set CONFIG=%EXAMPLES_DIR%\config

set PATH=%MODEL_OUT_DIR%;"%NEW_COHERENCE_CPP_HOME%\lib";%PATH%

set tangosol.coherence.override=%CONFIG%\tangosol-coherence-override.xml
set tangosol.coherence.cacheconfig=%CONFIG%\examples-extend-cache-config.xml
set tangosol.coherence.log=%EXAMPLE%.log

echo redirecting Coherence logging to %tangosol.coherence.log%...

if "%EXAMPLE%"=="console" (
   @rem the console is now embedded within the coherence shared library
   ..\bin\sanka -l coherence coherence::net::CacheFactory %2 %3 %4 %5 %6 %7 %8 %9
   goto exit
   )

if "%EXAMPLE%"=="sanka" (
   ..\bin\sanka %2 %3 %4 %5 %6 %7 %8 %9
   goto exit
   )

%EXEC% %2 %3 %4 %5 %6 %7 %8 %9

:exit
